#!/usr/bin/env node
import m from "node:path";
import i from "node:fs";
import S from "lodash.get";
import J from "lodash.set";
import o from "chalk";
const w = /(?<!\/):/, x = (e) => {
  const [t, r = t, ...s] = e.split(w);
  return {
    key: t,
    /** 目标key */
    targetKey: r,
    /** 参数列表 */
    paramsList: s
  };
}, v = ({
  valueInit: e,
  paramsList: t
}) => {
  const [r, ...s] = t;
  switch (r) {
    case "REG": {
      const [n, a, u] = s, f = new RegExp(n, u ?? void 0);
      return typeof e == "string" ? e.replace(f, a) : (console.log(
        o.yellow(
          `${e}不是字符串类型，无法使用正则表达式进行替换，此处将直接返回原值`
        )
      ), e);
    }
    case "VALUE": {
      const [n] = s;
      return n;
    }
    default:
      return e;
  }
}, L = async (e) => {
  const { sourceJsonFilePath: t, injectKeyPath: r, injectInfoFilePath: s } = e, n = process.cwd();
  if (!t.endsWith(".json"))
    return console.log(o.red("源文件必须是json")), process.exit(1);
  if (!s.endsWith(".json"))
    return console.log(o.red("注入文件必须是json")), process.exit(1);
  const a = m.resolve(n, t), u = i.readFileSync(a, "utf-8"), f = JSON.parse(u), p = r.reduce(
    (c, y) => {
      const { key: h, targetKey: d, paramsList: j } = x(y);
      if (!h)
        return console.log(o.red(`注入key不能为空,请检查配置${y}是否正确`)), c;
      const F = S(f, h), P = v({
        valueInit: F,
        paramsList: j
      });
      return J(c, d, P), c;
    },
    {}
  ), l = m.resolve(n, s), g = JSON.stringify(p, null, 2);
  if (i.existsSync(l)) {
    const c = i.readFileSync(l, "utf-8");
    if (g === c)
      return console.log(o.gray("注入文件已存在且内容相同，无需重复注入")), p;
    console.log(o.blue("文件内容变化,开始覆盖注入文件"));
  } else
    console.log(o.green("开始注入文件"));
  return i.writeFileSync(l, g), console.log(
    o.green(`文件注入成功: ${l}`),
    o.blue(g)
  ), p;
};
export {
  L as h
};
