#!/usr/bin/env node
import { h as i } from "./handler-1283dc4a.js";
import r from "yargs";
import { hideBin as l } from "yargs/helpers";
import s from "chalk";
const o = {
  version: "0.4.3",
  name: "@done-coding/cli-inject",
  description: "信息注入命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "inject"
  }
}, d = () => ({
  sourceJsonFilePath: {
    type: "string",
    alias: "s",
    describe: "信息源json文件相对路径",
    default: "./package.json"
  },
  injectKeyPath: {
    type: "array",
    alias: "k",
    describe: "需要注入的key路径",
    default: ["name", "version", "description"]
  },
  injectInfoFilePath: {
    type: "string",
    alias: "i",
    describe: "注入信息文件路径",
    default: "./src/injectInfo.json"
  }
}), a = o.cliConfig.moduleName, m = (e, n) => {
  console.log(e ? s.red(e) : s.red(n.message)), process.exit(1);
}, p = o.description, g = `Usage: $0 ${a} [options]`, f = "Usage: $0 [options]", t = (e, n) => {
  const c = d();
  return e.strict().usage(n).help("help").version(o.version).alias("v", "version").alias("h", "help").options(c).fail(m).argv;
}, u = (e) => t(e, g), b = {
  command: a,
  describe: p,
  builder: u,
  handler: i
}, C = async () => {
  const e = r(l(process.argv)), n = await t(e, f);
  return i(n);
};
export {
  b as a,
  C as c
};
